

# ListFindings
<a name="API_ListFindings"></a>

Retrieves a list of findings generated by the specified analyzer. ListFindings and ListFindingsV2 both use `access-analyzer:ListFindings` in the `Action` element of an IAM policy statement. You must have permission to perform the `access-analyzer:ListFindings` action.

To learn about filter keys that you can use to retrieve a list of findings, see [IAM Access Analyzer filter keys](https://docs.amazonaws.cn/IAM/latest/UserGuide/access-analyzer-reference-filter-keys.html) in the **IAM User Guide**.

**Note**  
ListFindings is supported only for external access analyzers. You must use ListFindingsV2 for internal and unused access analyzers.

## Request Syntax
<a name="API_ListFindings_RequestSyntax"></a>

```
POST /finding HTTP/1.1
Content-type: application/json

{
   "analyzerArn": "string",
   "filter": { 
      "string" : { 
         "contains": [ "string" ],
         "eq": [ "string" ],
         "exists": boolean,
         "neq": [ "string" ]
      }
   },
   "maxResults": number,
   "nextToken": "string",
   "sort": { 
      "attributeName": "string",
      "orderBy": "string"
   }
}
```

## URI Request Parameters
<a name="API_ListFindings_RequestParameters"></a>

The request does not use any URI parameters.

## Request Body
<a name="API_ListFindings_RequestBody"></a>

The request accepts the following data in JSON format.

 ** [analyzerArn](#API_ListFindings_RequestSyntax) **   <a name="accessanalyzer-ListFindings-request-analyzerArn"></a>
The [ARN of the analyzer](https://docs.amazonaws.cn/IAM/latest/UserGuide/access-analyzer-getting-started.html#permission-resources) to retrieve findings from.  
Type: String  
Pattern: `[^:]*:[^:]*:[^:]*:[^:]*:[^:]*:analyzer/.{1,255}`   
Required: Yes

 ** [filter](#API_ListFindings_RequestSyntax) **   <a name="accessanalyzer-ListFindings-request-filter"></a>
A filter to match for the findings to return.  
Type: String to [Criterion](API_Criterion.md) object map  
Required: No

 ** [maxResults](#API_ListFindings_RequestSyntax) **   <a name="accessanalyzer-ListFindings-request-maxResults"></a>
The maximum number of results to return in the response.  
Type: Integer  
Required: No

 ** [nextToken](#API_ListFindings_RequestSyntax) **   <a name="accessanalyzer-ListFindings-request-nextToken"></a>
A token used for pagination of results returned.  
Type: String  
Required: No

 ** [sort](#API_ListFindings_RequestSyntax) **   <a name="accessanalyzer-ListFindings-request-sort"></a>
The sort order for the findings returned.  
Type: [SortCriteria](API_SortCriteria.md) object  
Required: No

## Response Syntax
<a name="API_ListFindings_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "findings": [ 
      { 
         "action": [ "string" ],
         "analyzedAt": "string",
         "condition": { 
            "string" : "string" 
         },
         "createdAt": "string",
         "error": "string",
         "id": "string",
         "isPublic": boolean,
         "principal": { 
            "string" : "string" 
         },
         "resource": "string",
         "resourceControlPolicyRestriction": "string",
         "resourceOwnerAccount": "string",
         "resourceType": "string",
         "sources": [ 
            { 
               "detail": { 
                  "accessPointAccount": "string",
                  "accessPointArn": "string"
               },
               "type": "string"
            }
         ],
         "status": "string",
         "updatedAt": "string"
      }
   ],
   "nextToken": "string"
}
```

## Response Elements
<a name="API_ListFindings_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [findings](#API_ListFindings_ResponseSyntax) **   <a name="accessanalyzer-ListFindings-response-findings"></a>
A list of findings retrieved from the analyzer that match the filter criteria specified, if any.  
Type: Array of [FindingSummary](API_FindingSummary.md) objects

 ** [nextToken](#API_ListFindings_ResponseSyntax) **   <a name="accessanalyzer-ListFindings-response-nextToken"></a>
A token used for pagination of results returned.  
Type: String

## Errors
<a name="API_ListFindings_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
You do not have sufficient access to perform this action.  
HTTP Status Code: 403

 ** InternalServerException **   
Internal server error.    
 ** retryAfterSeconds **   
The seconds to wait to retry.
HTTP Status Code: 500

 ** ResourceNotFoundException **   
The specified resource could not be found.    
 ** resourceId **   
The ID of the resource.  
 ** resourceType **   
The type of the resource.
HTTP Status Code: 404

 ** ThrottlingException **   
Throttling limit exceeded error.    
 ** retryAfterSeconds **   
The seconds to wait to retry.
HTTP Status Code: 429

 ** ValidationException **   
Validation exception error.    
 ** fieldList **   
A list of fields that didn't validate.  
 ** reason **   
The reason for the exception.
HTTP Status Code: 400

## See Also
<a name="API_ListFindings_SeeAlso"></a>

For more information about using this API in one of the language-specific Amazon SDKs, see the following:
+  [Amazon Command Line Interface V2](https://docs.amazonaws.cn/goto/cli2/accessanalyzer-2019-11-01/ListFindings) 
+  [Amazon SDK for .NET V4](https://docs.amazonaws.cn/goto/DotNetSDKV4/accessanalyzer-2019-11-01/ListFindings) 
+  [Amazon SDK for C\$1\$1](https://docs.amazonaws.cn/goto/SdkForCpp/accessanalyzer-2019-11-01/ListFindings) 
+  [Amazon SDK for Go v2](https://docs.amazonaws.cn/goto/SdkForGoV2/accessanalyzer-2019-11-01/ListFindings) 
+  [Amazon SDK for Java V2](https://docs.amazonaws.cn/goto/SdkForJavaV2/accessanalyzer-2019-11-01/ListFindings) 
+  [Amazon SDK for JavaScript V3](https://docs.amazonaws.cn/goto/SdkForJavaScriptV3/accessanalyzer-2019-11-01/ListFindings) 
+  [Amazon SDK for Kotlin](https://docs.amazonaws.cn/goto/SdkForKotlin/accessanalyzer-2019-11-01/ListFindings) 
+  [Amazon SDK for PHP V3](https://docs.amazonaws.cn/goto/SdkForPHPV3/accessanalyzer-2019-11-01/ListFindings) 
+  [Amazon SDK for Python](https://docs.amazonaws.cn/goto/boto3/accessanalyzer-2019-11-01/ListFindings) 
+  [Amazon SDK for Ruby V3](https://docs.amazonaws.cn/goto/SdkForRubyV3/accessanalyzer-2019-11-01/ListFindings) 